import 'package:flutter/widgets.dart';

mixin FocusMixin {
  FocusNode get focusNode;

  BuildContext get context;

  showKeyboard(BuildContext context);

  /// Checks the build scope
  focus({BuildContext? context, bool verifyKeyboard = false}) {
    bool needsFocus = !focusNode.hasFocus;
    if (focusNode.hasFocus && verifyKeyboard) {
      showKeyboard(context ?? this.context);
    }

    /// Trying to troubleshoot focus issues - this seemed to help in the simulator
    if (needsFocus) {
      showKeyboard(context ?? this.context);
    }
//    if (needsFocus) {
//      FocusScope.of(this.context).requestFocus(focusNode);
//    }
  }

  focusVerify({BuildContext? context}) {
    return focus(context: context ?? this.context, verifyKeyboard: true);
  }
}
