import 'package:dartxx/dartxx.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:sunny_core_widgets/sunny_core_widgets.dart';
import 'package:sunny_forms/raw_text_field.dart';
import 'package:sunny_forms/sunny_form_controller.dart';
import 'package:sunny_forms/sunny_form_field.dart';
import 'package:sunny_service_stubs/models.dart';

class PhoneWithExtensionControl extends StatefulWidget {
  final FormValueChanged<IPhoneWithExtension> onChange;
  final IPhoneWithExtension? initialValue;

  const PhoneWithExtensionControl({
    Key? key,
    required this.onChange,
    required this.initialValue,
  }) : super(key: key);

  @override
  _PhoneWithExtensionControlState createState() => _PhoneWithExtensionControlState();
}

class _PhoneWithExtensionControlState extends State<PhoneWithExtensionControl> {
  String? _number;
  String? _extension;

  @override
  void initState() {
    super.initState();
    _number = widget.initialValue?.number;
    _extension = widget.initialValue?.extension;
  }

  _onChange(AttributeSource source) {
    widget.onChange.call(IPhoneWithExtension.of(number: _number, extension: _extension), source);
  }

  @override
  Widget build(BuildContext context) {
    return row([
      Container(
        width: 140,
        child: TextControl<String>.formField(
          attribute: JsonPath.of("number"),
          initialValue: _number,
          onChange: (number, source) {
            _number = number;
            _onChange(source);
          },
        ),
      ),
      hpad(Text(" ext. ")),
      Container(
        width: 80,
        child: TextControl<String>.formField(
          attribute: JsonPath.of("extension"),
          initialValue: _extension,
          onChange: (ext, source) {
            _extension = ext;
            _onChange(source);
          },
        ),
      ),
    ]);
  }
}
