import 'package:sunny_dart/sunny_dart.dart';

typedef InputConverter<T> = T Function(String input);

final numberRemoves = RegExp('[\$,]');

class InputConverters {
  InputConverters._();

  static final InputConverter<double?> doubles = (String input) {
    if (input.isNullOrBlank) return null;
    return input.trim().replaceAll(numberRemoves, "").toDouble();
  };

  static final InputConverter<int?> ints = (String input) {
    if (input.isNullOrBlank) return null;
    return input.trim().replaceAll(numberRemoves, "").toInt();
  };
}
