import 'package:equatable/equatable.dart';
import 'package:sunny_service_stubs/options.dart';

class FileSourceType extends Equatable {
  final String label;
  final String description;

  const FileSourceType.files()
      : label = "Upload a file",
        description = "From your computer/phone, iCloud, Dropbox, etc.";

  const FileSourceType.url()
      : label = "Paste a URL",
        description =
            "Paste a URL to an existing photo or video, eg. Muse, YouTube";

  const FileSourceType.gallery()
      : label = "Upload from gallery",
        description = "Photos and videos from your photo library";

  @override
  List<Object> get props => [label, description];

  Option<FileSourceType> toOption() =>
      Option(this, label: label, subtitle: [description]);
}
