import 'package:flutter/widgets.dart';
import 'package:sunny_forms/form_fields/location/location_typeahead.dart';
import 'package:sunny_forms/meta/meta_property_handler.dart';
import 'package:sunny_forms/meta/props/base_embed_property_handler.dart';
import 'package:sunny_forms/sunny_form_field.dart';
import 'package:sunny_service_stubs/meta.dart';
import 'package:sunny_service_stubs/models.dart';
import 'package:sunny_service_stubs/options.dart';

class LocationPropertyHandler extends BaseEmbedPropertyHandler {
  LocationPropertyHandler(IMSchemaService _) : super(_, PhysicalLocationRef);

  /// Renders a widget (or null) for a provided [HandledPaths] (see [acceptProperties])
  Iterable<Widget> renderProperty(BuildContext context,
      IMetaFormContext metaForm, HandledPaths paths, SunnyFormFieldState state,
      {Key? key}) {
    // final prop = metaForm.schema.getByPath(paths.path);
    return [
      PhysicalLocationTypeaheadControl(
        key: key,
        onChange: state.updateValue,
        initialValue: state.cast<IPhysicalLocation>().value,
      ),
    ];
  }
}
