import 'package:flutter/widgets.dart';
import 'package:sunny_dart/sunny_dart.dart';
import 'package:sunny_forms/form_fields/phone_with_extension_field.dart';
import 'package:sunny_forms/meta/meta_property_handler.dart';
import 'package:sunny_forms/sunny_form_field.dart';
import 'package:sunny_sdk_core/mverse/definitions.dart';
import 'package:sunny_sdk_core/sunny_sdk_core.dart';
import 'package:sunny_service_stubs/models.dart';
import 'package:sunny_service_stubs/options.dart';

class PhoneWithExtensionPropertyHandler extends MetaPropertyHandler {
  PhoneWithExtensionPropertyHandler();

  @override
  Iterable<Widget> renderProperty(BuildContext context,
      IMetaFormContext metaForm, HandledPaths paths, SunnyFormFieldState state,
      {Key? key}) {
    // final prop =
    //     paths.paths.values.firstOrNull ?? metaForm.schema.getByPath(paths.path);
    return [
      PhoneWithExtensionControl(
        key: key,
        onChange: state.updateValue,
        initialValue: state.cast<IPhoneWithExtension>().value,
      )
    ];
  }

  @override
  Iterable<HandledPaths> acceptProperties(
      JsonPath? basePath,
      IMSchemaDefinition definition,
      Map<JsonPath, IMSchemaProperty> available) {
    final handled = available
        .filterEntries(
            (k, v) => v.baseCode == Definitions.phoneWithExtension.baseCode)
        .mapEntries((k, v) => HandledPaths.ofProperty(v, basePath!, this));
    return handled;
  }
}
