import 'package:flutter/material.dart';
import 'package:sunny_platform_widgets/sunny_platform_widgets.dart';

class PlatformBody extends PlatformWidgetBase {
  final Widget? child;
  final Color? color;
  final BorderRadius? borderRadius;

  PlatformBody(
      {Key? key, this.color, this.borderRadius, this.child, extraOptions})
      : super(key: key, extraOptions: extraOptions);

  @override
  Widget createMaterialWidget(BuildContext context) {
    return Material(
      child: child,
      color: color,
      borderRadius: borderRadius,
    );
  }

  @override
  Widget createCupertinoWidget(BuildContext context) {
    return Container(
        child: child,
        decoration: BoxDecoration(
          color: color,
          borderRadius: borderRadius,
        ));
  }
}
