import 'package:flutter/widgets.dart';

typedef TextEditingBuilder = Widget Function(String value);

mixin TextEditingControllerExt on TextEditingController {
  Widget builder(TextEditingBuilder builder) {
    return TextEditingListener(controller: this, builder: builder);
  }
}

class TextEditingListener extends StatefulWidget {
  final TextEditingController? controller;
  final TextEditingBuilder? builder;

  const TextEditingListener({Key? key, this.controller, this.builder})
      : super(key: key);
  @override
  _TextEditingListenerState createState() => _TextEditingListenerState();
}

class _TextEditingListenerState extends State<TextEditingListener> {
  @override
  Widget build(BuildContext context) {
    return widget.builder!(widget.controller!.text);
  }

  @override
  void initState() {
    super.initState();
    widget.controller!.addListener(_textChanged);
  }

  void _textChanged() {
    if(mounted) {
      setState(() {});
    }
  }

  @override
  void dispose() {
    widget.controller!.removeListener(_textChanged);
    super.dispose();
  }
}
