import 'package:flutter/material.dart';

InputDecoration applyTheme(BuildContext context,
    {required InputDecoration decoration}) {
  final theme = Theme.of(context).inputDecorationTheme;
  return decoration.applyDefaults(theme);
}

const defaultInputPadding = EdgeInsets.only(
  bottom: 12,
  top: 12,
);

EdgeInsets inputPadding({bool suffix = false, bool prefix = false}) {
  var padding = defaultInputPadding;
  if (suffix == true) padding += suffixInputPadding;
  if (prefix == true) padding += prefixInputPadding;
  return padding;
}

const prefixInputPadding = EdgeInsets.only(left: 40);
const suffixInputPadding = EdgeInsets.only(right: 25);
