import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class FixedPinnedHeader extends SliverPersistentHeaderDelegate {
  final double fixedHeight;
  final Widget child;

  const FixedPinnedHeader({required this.fixedHeight, required this.child});

  FixedPinnedHeader.ofPreferredSize({required PreferredSizeWidget child})
      : child = child,
        fixedHeight = child.preferredSize.height;

  @override
  Widget build(
    BuildContext context,
    double shrinkOffset,
    bool overlapsContent,
  ) {
    return child;
  }

  @override
  double get maxExtent => fixedHeight;

  @override
  double get minExtent => fixedHeight;

  @override
  bool shouldRebuild(SliverPersistentHeaderDelegate oldDelegate) => false;
}
